找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1065|回复: 0

[分享] Count blocks by attribute value

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:20:19 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        // using System.Linq;
        #region "Selection block by attribute tag"

        //      get the real block name.        //     
        public static string EffectiveName(Transaction tr, BlockReference bref)
        {
            BlockTableRecord btr = null;
            if ((bref.IsDynamicBlock)
                | (bref.Name.StartsWith("*U", StringComparison.InvariantCultureIgnoreCase)))
            {
                btr = tr.GetObject(bref.DynamicBlockTableRecord, OpenMode.ForRead) as BlockTableRecord;
            }
            else
            {
                btr = tr.GetObject(bref.BlockTableRecord, OpenMode.ForRead) as BlockTableRecord;
            }
            return btr.Name;
        }
        [CommandMethod("SelectByAttributeValue", "byval", CommandFlags.Modal)]
        public void GetSelectionByAtt()
        {

            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Database db = doc.Database;

            Editor ed = doc.Editor;

            string m_str = string.Empty;

            PromptStringOptions psto = new PromptStringOptions("\nEnter the tag to find (case-nonsensitive): ");
            // to disable the blank space in user input
            psto.AllowSpaces = false;

            PromptResult pstr = ed.GetString(psto);

            if (pstr.Status != PromptStatus.OK) return;

            m_str = pstr.StringResult.ToUpper();

            List<object[]> blockdata = new List<object[]>();

            PromptSelectionOptions pso = new PromptSelectionOptions();

            pso.MessageForRemoval = "\nFailed to select a blocks!";

            pso.MessageForAdding = "\nPlease select a blocks: ";

            // build filter to select all attributed blocks
            SelectionFilter filter =
                new SelectionFilter(
                new TypedValue[] { new TypedValue(0, "insert"),
                    new TypedValue(66, 1) }
                    );

            // perform block selection
            PromptSelectionResult sres = ed.GetSelection(pso, filter);// might be SelectAll instead

            if (sres.Status != PromptStatus.OK) return;
            try
            {

                SelectionSet sset = sres.Value;

                using (Transaction tr = db.TransactionManager.StartTransaction())
                {

                    foreach (SelectedObject sobj in sset)
                    {
                        Entity ent = tr.GetObject(sobj.ObjectId, OpenMode.ForRead, false) as Entity;

                        BlockReference bref = ent as BlockReference;

                        AttributeCollection attribs = bref.AttributeCollection;

                        foreach (ObjectId attid in attribs)
                        {
                            AttributeReference attref = tr.GetObject(attid, OpenMode.ForRead, false) as AttributeReference;

                            if (attref.Tag == m_str)
                            {

                                object[] datum = new object[] { EffectiveName(tr, bref), attref.Tag, attref.TextString };
                                // add block  info to the list
                                blockdata.Add(datum);

                            }
                        }
                    }
                    // display total result
                    //foreach (object[] item in blockdata)
                    //    ed.WriteMessage("\n{0}\t{1}\t{2}", item[0], item[1],item[2]);
                    var grps = from blk in blockdata
    group blk by new
    {
        Name =blk.ElementAt(0), Tag =blk.ElementAt(1),AttValue=blk.ElementAt(2)
    }
    into grp
    select new
    {
        BlockName=grp.First().ElementAt(0),
        Tag=grp.First().ElementAt(1),
        AttValue=grp.First().ElementAt(2),
        Count= grp.Count()
    };

                    // display subtotals
                    foreach (var grp in grps)
                    {
                        ed.WriteMessage("\n[ Block Name: {0} |Tag: {1} | Value: {2} | Count: {3} ]\n",
                            grp.BlockName,
                            grp.Tag,
                            grp.AttValue,
                            grp.Count
        );
                    }
                    tr.Commit();

                }
            }
            catch (System.Exception ex)
            {
                Autodesk.AutoCAD.ApplicationServices.Application.ShowAlertDialog(ex.Message + "\n" + ex.StackTrace);
            }
            finally
            {
            }
        }
        #endregion
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-23 00:24 , Processed in 0.329178 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表